"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const metrics = __importStar(require("./metrics"));
const metricNames = ['euclidean',
    'manhattan',
    'braycurtis',
    'chebyshev',
    'canberra',
    'hamming'
];
function pairwiseDistance(d) {
    let distFn = d === undefined ? metrics['euclidean'] : metrics[d];
    let fx;
    let fy;
    function g(x, y) {
        return g.distance(x, y);
    }
    g.distance = function (x, y) {
        if (x.length !== y.length)
            throw new RangeError('Vectors must be of equivalent length');
        return (fx && fy)
            ? distFn(x.map(fx), y.map(fy))
            : distFn(x, y);
    };
    g.x = function (fn) {
        fx = fn;
        return g;
    };
    g.y = function (fn) {
        fy = fn;
        return g;
    };
    g.func = function (fn) {
        distFn = fn;
        return g;
    };
    return g;
}
exports.pairwiseDistance = pairwiseDistance;
